diff --git a/src/main/java/net/minecraft/client/gui/GuiTextureViewer.java b/src/main/java/net/minecraft/client/gui/TextureViewerScreen.java
similarity index 67%
rename from src/main/java/net/minecraft/client/gui/GuiTextureViewer.java
rename to src/main/java/net/minecraft/client/gui/TextureViewerScreen.java
index f416f7538..6d07f2ad3 100644
--- a/src/main/java/net/minecraft/client/gui/GuiTextureViewer.java
+++ b/src/main/java/net/minecraft/client/gui/TextureViewerScreen.java
@@ -1,11 +1,10 @@
 package net.minecraft.client.gui;
 
 import net.minecraft.client.GLAllocation;
-import net.minecraft.client.gui.modelviewer.elements.GuiListenerButton;
+import net.minecraft.client.gui.modelviewer.elements.ListenerButtonElement;
 import net.minecraft.client.gui.modelviewer.elements.IListenerElement;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texture.Texture;
-import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.util.helper.Textures;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.util.helper.Utils;
@@ -22,14 +21,14 @@ import static org.lwjgl.opengl.GL11.GL_TEXTURE_HEIGHT;
 import static org.lwjgl.opengl.GL11.GL_TEXTURE_WIDTH;
 import static org.lwjgl.opengl.GL11.glGetTexLevelParameteri;
 
-public class GuiTextureViewer extends GuiScreen{
+public class TextureViewerScreen extends Screen {
     private static final int TOP_SPACING = 24;
     private static final int BUTTON_SPACING = 4;
 
     protected int top;
     protected int bottom;
 
-    protected GuiListenerButton leftTexCycle;
+    protected ListenerButtonElement leftTexCycle;
 
     protected int texIndex = 0;
 
@@ -37,33 +36,33 @@ public class GuiTextureViewer extends GuiScreen{
     protected boolean flip = false;
     protected boolean drawText = true;
 
-    public GuiTextureViewer(GuiScreen parent) {
+    public TextureViewerScreen(Screen parent) {
         super(parent);
     }
 
     @Override
-    public void keyTyped(char c, int key, int mouseX, int mouseY)
+    public void keyPressed(char eventCharacter, int eventKey, int mx, int my)
     {
-        if (key == Keyboard.KEY_LEFT) {
+        if (eventKey == Keyboard.KEY_LEFT) {
             cycleTexture(-1);
-        } else if (key == Keyboard.KEY_RIGHT) {
+        } else if (eventKey == Keyboard.KEY_RIGHT) {
             cycleTexture(1);
-        } else if (key == Keyboard.KEY_ESCAPE) {
-            mc.displayGuiScreen(parentScreen);
+        } else if (eventKey == Keyboard.KEY_ESCAPE) {
+            mc.displayScreen(parentScreen);
         }
-        List<GuiButton> _buttons = new ArrayList<>(controlList);
-        for (GuiButton button : _buttons){
-            if (button instanceof IListenerElement && button.isHovered(mouseX, mouseY)){
-                ((IListenerElement<?>) button).onKeyTyped(c, key);
+        List<ButtonElement> _buttons = new ArrayList<>(buttons);
+        for (ButtonElement button : _buttons){
+            if (button instanceof IListenerElement && button.isHovered(mx, my)){
+                ((IListenerElement<?>) button).onKeyTyped(eventCharacter, eventKey);
             }
         }
     }
     @Override
     public void tick(){
-        List<GuiButton> _buttons = new ArrayList<>(controlList);
-        for (GuiButton button : _buttons){
-            if (button instanceof GuiListenerButton){
-                ((GuiListenerButton) button).tick();
+        List<ButtonElement> _buttons = new ArrayList<>(buttons);
+        for (ButtonElement button : _buttons){
+            if (button instanceof ListenerButtonElement){
+                ((ListenerButtonElement) button).tick();
             }
         }
     }
@@ -72,38 +71,38 @@ public class GuiTextureViewer extends GuiScreen{
 
         top = TOP_SPACING;
         bottom = height - (BUTTON_SPACING + 20 + BUTTON_SPACING);
-        add(new GuiListenerButton(0, width/2 - 100, height - (BUTTON_SPACING + 20), 200, 20, I18n.getInstance().translateKey("gui.options.button.done")).setActionListener(() -> {
-            onClosed();
-            mc.displayGuiScreen(null);
+        add(new ListenerButtonElement(0, width/2 - 100, height - (BUTTON_SPACING + 20), 200, 20, I18n.getInstance().translateKey("gui.options.button.done")).setActionListener(() -> {
+            removed();
+            mc.displayScreen(null);
         }));
 
-        leftTexCycle = add(new GuiListenerButton(1, width - (20 + BUTTON_SPACING) * 2, bottom - (BUTTON_SPACING + 20), 20, 20, "<")
+        leftTexCycle = add(new ListenerButtonElement(1, width - (20 + BUTTON_SPACING) * 2, bottom - (BUTTON_SPACING + 20), 20, 20, "<")
             .setActionListener(() -> cycleTexture(-1)));
-        add(new GuiListenerButton(2, width - (20 + BUTTON_SPACING) * 1, bottom - (BUTTON_SPACING + 20), 20, 20, ">")
+        add(new ListenerButtonElement(2, width - (20 + BUTTON_SPACING) * 1, bottom - (BUTTON_SPACING + 20), 20, 20, ">")
             .setActionListener(() -> cycleTexture(1)));
 
-        add(new GuiListenerButton(11, BUTTON_SPACING, bottom - BUTTON_SPACING - 20, 20, 20, "V")
+        add(new ListenerButtonElement(11, BUTTON_SPACING, bottom - BUTTON_SPACING - 20, 20, 20, "V")
             .setActionListener(() -> drawCheckers = !drawCheckers)
         );
-        add(new GuiListenerButton(11, 20 + BUTTON_SPACING * 2, bottom - BUTTON_SPACING - 20, 20, 20, "F")
+        add(new ListenerButtonElement(11, 20 + BUTTON_SPACING * 2, bottom - BUTTON_SPACING - 20, 20, 20, "F")
             .setActionListener(() -> flip = !flip)
         );
-        add(new GuiListenerButton(12, 40 + BUTTON_SPACING * 3, bottom - BUTTON_SPACING - 20, 20, 20, "D")
+        add(new ListenerButtonElement(12, 40 + BUTTON_SPACING * 3, bottom - BUTTON_SPACING - 20, 20, 20, "D")
             .setActionListener(() -> {
                 Textures.dumpTextures();
                 Utils.openDirectory(new File("dumpTextures"));
             })
         );
-        add(new GuiListenerButton(13, 60 + BUTTON_SPACING * 4, bottom - BUTTON_SPACING - 20, 20, 20, "T")
+        add(new ListenerButtonElement(13, 60 + BUTTON_SPACING * 4, bottom - BUTTON_SPACING - 20, 20, 20, "T")
             .setActionListener(() -> drawText = !drawText)
         );
     }
 
-    protected void buttonPressed(GuiButton button)
+    protected void buttonClicked(ButtonElement button)
     {
     }
 
-    protected void buttonReleased(GuiButton button)
+    protected void buttonReleased(ButtonElement button)
     {
     }
 
@@ -116,16 +115,16 @@ public class GuiTextureViewer extends GuiScreen{
         texIndex = texIndex % textureList.size();
     }
 
-    public void drawScreen(int mouseX, int mouseY, float partialTick) {
-        drawDefaultBackground();
+    public void render(int xm, int ym, float partialTick) {
+        renderBackground();
 
-        fontRenderer.drawCenteredString(I18n.getInstance().translateKey("gui.texture_viewer.label.title"), width/2, 5, 0xFFFFFF);
+        font.drawCenteredString(I18n.getInstance().translateKey("gui.texture_viewer.label.title"), width/2, 5, 0xFFFFFF);
 
         List<Integer> textureList = GLAllocation.textureNames;
         int id = texIndex % textureList.size();
         GL11.glBindTexture(GL_TEXTURE_2D, textureList.get(id));
 
-        Texture t = mc.renderEngine.idToTextureMap.get(textureList.get(id));
+        Texture t = mc.textureManager.idToTextureMap.get(textureList.get(id));
 
 
         GL11.glEnable(GL_BLEND);
@@ -149,7 +148,7 @@ public class GuiTextureViewer extends GuiScreen{
         Tessellator tessellator = Tessellator.instance;
 
         if (drawCheckers) {
-            mc.renderEngine.bindTexture(mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/designer_bg.png"));
+            mc.textureManager.bindTexture(mc.textureManager.loadTexture("/assets/minecraft/textures/gui/designer_bg.png"));
             tessellator.startDrawingQuads();
             tessellator.addVertexWithUV(x + 0,         y + imgHeight,   zLevel, 0,          imgHeight/2);
             tessellator.addVertexWithUV(x + imgWidth,  y + imgHeight,   zLevel, imgWidth/2, imgHeight/2);
@@ -182,14 +181,14 @@ public class GuiTextureViewer extends GuiScreen{
 
 //        drawGuiIcon((width - bw)/2, (height - bh)/2, bw, bh, TextureRegistry.getTexture("minecraft:gui/widgets/button"));
 
-        super.drawScreen(mouseX, mouseY, partialTick);
+        super.render(xm, ym, partialTick);
 
         GL11.glDisable(GL11.GL_DEPTH_TEST);
 
         if (drawText) {
-            fontRenderer.drawString("Tex ID: " + id , 1, top + 1, 0xFFFFFF, true);
-            fontRenderer.drawString("Tex Width: " + texWidth, 1, top + 11, 0xFFFFFF, true);
-            fontRenderer.drawString("Tex Height: " + texHeight, 1, top + 21, 0xFFFFFF, true);
+            font.drawString("Tex ID: " + id , 1, top + 1, 0xFFFFFF, true);
+            font.drawString("Tex Width: " + texWidth, 1, top + 11, 0xFFFFFF, true);
+            font.drawString("Tex Height: " + texHeight, 1, top + 21, 0xFFFFFF, true);
 
             String s;
             if (t == null) {
@@ -200,19 +199,19 @@ public class GuiTextureViewer extends GuiScreen{
             String[] lines = s.split("\n");
             int yOff = top + 31;
             for (String line : lines) {
-                fontRenderer.drawString(line, 1, yOff, 0xFFFFFF, true);
+                font.drawString(line, 1, yOff, 0xFFFFFF, true);
                 yOff += 10;
             }
         }
     }
     @Override
-    public void drawDefaultBackground() {
-        super.drawDefaultBackground();
+    public void renderBackground() {
+        super.renderBackground();
 
         if (mc.theWorld == null)
         {
             Tessellator tessellator = Tessellator.instance;
-            mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
+            mc.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
             float scale = 32F;
             tessellator.startDrawingQuads();
diff --git a/src/main/java/net/minecraft/client/gui/GuiTexturedButton.java b/src/main/java/net/minecraft/client/gui/TexturedButtonElement.java
similarity index 81%
rename from src/main/java/net/minecraft/client/gui/GuiTexturedButton.java
rename to src/main/java/net/minecraft/client/gui/TexturedButtonElement.java
index e7f2e164f..e8627cecb 100644
--- a/src/main/java/net/minecraft/client/gui/GuiTexturedButton.java
+++ b/src/main/java/net/minecraft/client/gui/TexturedButtonElement.java
@@ -3,12 +3,12 @@ package net.minecraft.client.gui;
 import net.minecraft.client.Minecraft;
 import org.lwjgl.opengl.GL11;
 
-public class GuiTexturedButton extends GuiButton {
+public class TexturedButtonElement extends ButtonElement {
     private final String texturePath;
     private int u;
     private int v;
 
-    public GuiTexturedButton(int id, String texturePath, int xPosition, int yPosition, int u, int v, int width, int height) {
+    public TexturedButtonElement(int id, String texturePath, int xPosition, int yPosition, int u, int v, int width, int height) {
         super(id, xPosition, yPosition,width, height, "");
         this.texturePath = texturePath;
         this.u = u;
@@ -20,7 +20,7 @@ public class GuiTexturedButton extends GuiButton {
         if (!visible) {
             return;
         }
-        mc.renderEngine.loadTexture(texturePath).bind();
+        mc.textureManager.loadTexture(texturePath).bind();
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         boolean isHovered = mouseX >= xPosition && mouseY >= yPosition && mouseX < xPosition + width && mouseY < yPosition + height;
         if (!enabled)
diff --git a/src/main/java/net/minecraft/client/gui/GuiTooltip.java b/src/main/java/net/minecraft/client/gui/TooltipElement.java
similarity index 97%
rename from src/main/java/net/minecraft/client/gui/GuiTooltip.java
rename to src/main/java/net/minecraft/client/gui/TooltipElement.java
index c9a42285b..54353f1d0 100644
--- a/src/main/java/net/minecraft/client/gui/GuiTooltip.java
+++ b/src/main/java/net/minecraft/client/gui/TooltipElement.java
@@ -6,7 +6,7 @@ import net.minecraft.core.data.registry.recipe.entry.RecipeEntryTrommel;
 import net.minecraft.core.data.registry.recipe.RecipeSymbol;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.client.option.enums.TooltipStyle;
-import net.minecraft.client.render.FontRenderer;
+import net.minecraft.client.render.Font;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.player.inventory.slot.Slot;
 import net.minecraft.core.player.inventory.slot.ResultSlot;
@@ -18,15 +18,15 @@ import org.lwjgl.opengl.GL11;
 
 import com.mojang.nbt.CompoundTag;
 
-public class GuiTooltip extends Gui
+public class TooltipElement extends Gui
 {
     Minecraft mc;
-    FontRenderer fr;
+    Font fr;
 
-    public GuiTooltip(Minecraft mc)
+    public TooltipElement(Minecraft mc)
     {
         this.mc = mc;
-        this.fr = mc.fontRenderer;
+        this.fr = mc.font;
     }
     public static final int BASE_PADDING = 3;
     public static final int LINE_SPACING = 3;
@@ -117,7 +117,7 @@ public class GuiTooltip extends Gui
 
         Tessellator tl = Tessellator.instance;
 
-        mc.renderEngine.bindTexture(mc.renderEngine.loadTexture(mc.gameSettings.tooltipStyle.value.getFilePath()));
+        mc.textureManager.bindTexture(mc.textureManager.loadTexture(mc.gameSettings.tooltipStyle.value.getFilePath()));
 
         GL11.glEnable(GL11.GL_BLEND);
         GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
diff --git a/src/main/java/net/minecraft/client/gui/GuiWandPickerMonster.java b/src/main/java/net/minecraft/client/gui/WandMobPickerScreen.java
similarity index 89%
rename from src/main/java/net/minecraft/client/gui/GuiWandPickerMonster.java
rename to src/main/java/net/minecraft/client/gui/WandMobPickerScreen.java
index e6dd56191..a54c7e0f9 100644
--- a/src/main/java/net/minecraft/client/gui/GuiWandPickerMonster.java
+++ b/src/main/java/net/minecraft/client/gui/WandMobPickerScreen.java
@@ -1,6 +1,6 @@
 package net.minecraft.client.gui;
 
-import net.minecraft.client.gui.popup.GuiPopup;
+import net.minecraft.client.gui.popup.PopupScreen;
 import net.minecraft.client.gui.popup.PopupBuilder;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityDispatcher;
@@ -14,13 +14,13 @@ import java.util.ArrayList;
 import java.util.Collections;
 import java.util.List;
 
-public class GuiWandPickerMonster extends GuiScreen {
+public class WandMobPickerScreen extends Screen {
     private String mobId;
     private boolean shouldClose = false;
     private final ItemStack wand;
 
 
-    public GuiWandPickerMonster(String mobId, ItemStack itemStack) {
+    public WandMobPickerScreen(String mobId, ItemStack itemStack) {
         this.mobId = mobId;
         wand = itemStack;
     }
@@ -46,7 +46,7 @@ public class GuiWandPickerMonster extends GuiScreen {
             prettyMonsters.add(sb.toString());
         }
 
-        GuiPopup popup = new PopupBuilder(this, 150)
+        PopupScreen popup = new PopupBuilder(this, 150)
                 .withLabel("gui.pick_monster.label.title")
                 .withList("list", 140, prettyMonsters.toArray(new String[0]), null, -1, true)
                 .closeOnEsc(0)
@@ -63,14 +63,14 @@ public class GuiWandPickerMonster extends GuiScreen {
                     shouldClose = true;
                 })
                 .build();
-        mc.displayGuiScreen(popup);
+        mc.displayScreen(popup);
     }
 
     @Override
     public void tick() {
         super.tick();
         if (shouldClose) {
-            mc.displayGuiScreen(null);
+            mc.displayScreen(null);
         }
     }
 
